package org.dive4elements.river.importer;

import java.util.List;

import org.dive4elements.river.model.GrainFraction;
import org.dive4elements.river.model.SedimentLoad;
import org.dive4elements.river.model.TimeInterval;
import org.hibernate.Query;
import org.hibernate.Session;

public class ImportSedimentLoad
{
    private SedimentLoad peer;

    private ImportGrainFraction grainFraction;
    private ImportTimeInterval  timeInterval;
    private ImportTimeInterval  sqTimeInterval;
    private String              description;
    private Integer             kind;

    public ImportSedimentLoad() {
    }

    public void storeDependencies() {
        grainFraction.getPeer();
        timeInterval.getPeer();
        sqTimeInterval.getPeer();

        getPeer();
    }

    public SedimentLoad getPeer() {

        if (peer == null) {
            Session session = ImporterSession.getInstance().getDatabaseSession();
            Query query = session.createQuery(
                "from SedimentLoad where " +
                "   grainFraction = :grainFraction and " +
                "   timeInterval = :timeInterval and " +
                "   sqTimeInterval = :sqTimeInterval and " +
                "   description = :description and " +
                "   kind = :kind");

            GrainFraction gf = grainFraction.getPeer();
            TimeInterval  ti = timeInterval.getPeer();

            TimeInterval sqti = sqTimeInterval != null
                ? sqTimeInterval.getPeer()
                : null;

            query.setParameter("grainFraction", gf);
            query.setParameter("timeInterval", ti);
            query.setParameter("sqTimeInterval", sqti);
            query.setParameter("description", description);
            query.setParameter("kind", kind);

            List<SedimentLoad> loads = query.list();
            if (loads.isEmpty()) {
                peer = new SedimentLoad(gf, ti, sqti, description, kind);
                session.save(peer);
            }
            else {
                peer = loads.get(0);
            }
        }

        return peer;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
